package it.integry.integrywmsnative.gest.ordini_uscita_elenco.filters;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.databinding.DataBindingUtil;
import androidx.lifecycle.MutableLiveData;

import com.annimon.stream.ComparatorCompat;
import com.annimon.stream.Stream;
import com.ravikoradiya.liveadapter.LiveAdapter;

import java.util.ArrayList;
import java.util.List;
import java.util.Locale;
import java.util.Objects;

import it.integry.integrywmsnative.BR;
import it.integry.integrywmsnative.R;
import it.integry.integrywmsnative.core.di.BindableBoolean;
import it.integry.integrywmsnative.core.expansion.RunnableArgs;
import it.integry.integrywmsnative.core.utility.UtilityBoolean;
import it.integry.integrywmsnative.databinding.LayoutFilterViaggioBinding;
import it.integry.integrywmsnative.ui.filter_chips.FilterLayoutView;

public class FilterViaggioLayoutView extends FilterLayoutView {

    protected LayoutFilterViaggioBinding mBindings;

    private List<Integer> allIDViaggio;
    private List<Integer> availableIDViaggio;
    private List<Integer> preSelectedIDViaggio = new ArrayList<>();
    private List<Integer> hiddenIDViaggio = new ArrayList<>();
    private MutableLiveData<List<ListModel>> listModel = new MutableLiveData<>();

    private RunnableArgs<List<Integer>> onFilterApplied;

    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        mBindings = DataBindingUtil.inflate(inflater, R.layout.layout_filter_viaggio, container, false);
        this.mBindings.setView(this);

        refreshList();

        this.setSearchView(this.mBindings.searchView, newFilter -> {
            hiddenIDViaggio = Stream.of(allIDViaggio)
                    .filter(x -> !x.toString().toUpperCase(Locale.ROOT).contains(newFilter.toUpperCase(Locale.ROOT)))
                    .toList();

            refreshList();
        });


        new LiveAdapter(listModel, getViewLifecycleOwner(), BR.item)
                .map(ListModel.class, R.layout.layout_filter_viaggio__list_item)
                .into(this.mBindings.recyclerview);

        return mBindings.getRoot();
    }

    private void refreshList() {
        ComparatorCompat<ListModel> c =
                ComparatorCompat
                        .chain(new ComparatorCompat<ListModel>((x, y) -> UtilityBoolean.toInt(x.getSelected().get()) - UtilityBoolean.toInt(y.getSelected().get())))
                        .thenComparing(new ComparatorCompat<>((x, y) -> UtilityBoolean.toInt(x.getEnabled().get()) - UtilityBoolean.toInt(y.getEnabled().get())))
                        .thenComparing(new ComparatorCompat<>((x, y) -> y.getOriginalModel().compareTo(x.getOriginalModel())))
                        .reversed();

        listModel.setValue(Stream.of(getAllIDViaggio())
                .filter(x -> !hiddenIDViaggio.contains(x))
                .map(x -> {
                    var selectedBoolean = new BindableBoolean(preSelectedIDViaggio.contains(x));
                    selectedBoolean.addOnPropertyChangedCallback(() -> {
                        if (selectedBoolean.get()) preSelectedIDViaggio.add(x);
                        else preSelectedIDViaggio.remove(x);
                    });

                    return new ListModel()
                            .setSelected(selectedBoolean)
                            .setEnabled(new BindableBoolean(availableIDViaggio.contains(x)))
                            .setOriginalModel(x);
                })
                .sorted(c)
                .toList());
    }


    public void onConfirm() {
        if (onFilterApplied == null) return;

        this.onFilterApplied.run(Stream.of(Objects.requireNonNull(listModel.getValue()))
                .filter(x -> x.selected.get())
                .map(x -> x.originalModel)
                .toList());

        dismiss();
    }

    public List<Integer> getAllIDViaggio() {
        return allIDViaggio;
    }

    public FilterViaggioLayoutView setAllIDViaggio(List<Integer> allIDViaggio) {
        this.allIDViaggio = allIDViaggio;
        return this;
    }

    public List<Integer> getAvailableIDViaggio() {
        return availableIDViaggio;
    }

    public FilterViaggioLayoutView setAvailableIDViaggio(List<Integer> availableIDViaggio) {
        this.availableIDViaggio = availableIDViaggio;
        return this;
    }

    public List<Integer> getPreSelectedIDViaggio() {
        return preSelectedIDViaggio;
    }

    public FilterViaggioLayoutView setPreSelectedIDViaggio(List<Integer> preSelectedIDViaggio) {
        this.preSelectedIDViaggio = preSelectedIDViaggio;
        return this;
    }

    public RunnableArgs<List<Integer>> getOnFilterApplied() {
        return onFilterApplied;
    }

    public FilterViaggioLayoutView setOnFilterApplied(RunnableArgs<List<Integer>> onFilterApplied) {
        this.onFilterApplied = onFilterApplied;
        return this;
    }

    public static class ListModel {
        private BindableBoolean selected = new BindableBoolean();
        private BindableBoolean enabled = new BindableBoolean();
        private Integer originalModel;

        public BindableBoolean getSelected() {
            return selected;
        }

        public ListModel setSelected(BindableBoolean selected) {
            this.selected = selected;
            return this;
        }

        public BindableBoolean getEnabled() {
            return enabled;
        }

        public ListModel setEnabled(BindableBoolean enabled) {
            this.enabled = enabled;
            return this;
        }

        public Integer getOriginalModel() {
            return originalModel;
        }

        public ListModel setOriginalModel(Integer originalModel) {
            this.originalModel = originalModel;
            return this;
        }
    }

}
